//============================================================================
//	apci54s.pas
//
//	aPCI-P54
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/09/10
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//============================================================================
unit apci54s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci54w;

const
	szTitle = 'Sample';
	szP54		= 'aPCI-P54';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(szBuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//	۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
	wLogSlot:	Word;								// ޲̘_ۯĔԍi[
	Ri:				TAPCI54RESOURCE;		// ؿ
	dwDLLVer, dwDriverVer: DWord;
	dwSwVal:	DWord;							// ۰ذ̒l
	dwDirections: Dword;          // ިڸ
	cbDat:		Byte;
	bResult:	Boolean;						// 
	szBuf:		String;
begin
	//-------------------------------------------------
	// apci54.dll ̎gp錾
	//-------------------------------------------------
	if Apci54wDllOpen() = False then begin
		ErrorMessage(APCI54_SLOT_AUTO);
		Exit;											// apci54.dll ۰ނɎs܂
	end;
	//-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P54 DLL,ײްްޮݔԍ擾
	//-------------------------------------------------
	if Apci54wGetVersion(dwDLLVer, dwDriverVer) = False then begin
		ErrorMessage(APCI54_SLOT_AUTO);
		Exit;
	end;

	szBuf := Format('GetVersion'#10 +
									'DLL Version'#09+ ': %08xH'#10 +
									'Driver Version'#09+ ': %08xH',
									[dwDLLVer, dwDriverVer]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-P54̎gp錾
	//-------------------------------------------------
	wLogSlot := APCI54_SLOT_AUTO;					// gp޲T܂B
	bResult := Apci54wCreate(wLogSlot);		// ꍇA̎޲̘_ۯĔԍi[܂B
	if bResult = False then begin					// ޲܂B
		ErrorMessage(APCI54_SLOT_AUTO);
		Exit;
	end;
	szBuf := Format('aPCI-P54 Created'#10#10 +
									'LogSlot: %2d'
									,[wLogSlot]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-------------------------------------------------
	if Apci54wGetResource(wLogSlot, Ri) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	if Apci54wGetSwitchValue(wLogSlot, dwSwVal) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Board Name: %s'#10 +
									 'IO Address: %04xH-%04xH'#10 +
									 'Switch    : %04xH',
									 [szP54,
										Ri.dwIOPortBase[1],
										Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
										dwSwVal]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port A ިڸ݂o͂ɐݒ肷
	//-------------------------------------------------
	if Apci54wGetDirections(wLogSlot, dwDirections) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	dwDirections := (not APCI54_DIR_A_INPUT) and dwDirections;	// A Port ޯĂo͂ɕύX
	if Apci54wSetDirections(wLogSlot, dwDirections) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('Port A ̃fBNVo͂ɕύX');
	//-------------------------------------------------
	// Port A ɔCӂްo
	//-------------------------------------------------
	cbDat := Byte($AA);
	if Apci54wOutPort(wLogSlot, APCI54_PORT_A, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port A փf[^o'#10 +
					 				 'Port A Out Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// Port A ިڸ݂͂ɐݒ
	//-------------------------------------------------
	if Apci54wGetDirections(wLogSlot, dwDirections) = False then begin
  	ErrorMessage(wLogSlot);
		Exit;
	end;
	dwDirections := APCI54_DIR_A_INPUT or dwDirections;	// A Port ޯĂ͂ɕύX
	if Apci54wSetDirections(wLogSlot, dwDirections) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('Port A ̃fBNV͂ɕύX');
	//-------------------------------------------------
	// Port A ްǂݍ
	//-------------------------------------------------
	cbDat := Byte($00);
	if Apci54wInPort(wLogSlot, APCI54_PORT_A, cbDat) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	szBuf := Format( 'Port A f[^'#10 +
									 'Port A In Data: %02xH',
									 [cbDat]);
	ResultMessage(szBuf);
	//-------------------------------------------------
	// aPCI-P54̎gpJ
	//-------------------------------------------------
	if Apci54wClose(wLogSlot) = False then begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	ResultMessage('aPCI-P54 Closed');
	//-------------------------------------------------
	// apci54.dll ̎gpJ
	//-------------------------------------------------
	if Apci54wDllClose() = False then begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;
	end;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	szBuf: String;
begin
	dwRes := Apci54wGetLastError(wLogSlot);
	case dwRes of
		APCI54_ERR_SYSTEM:
			szBuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		APCI54_ERR_WRAPDLL:
    	szBuf := 'DLL Load error';
		else
			szBuf := Format('aPCI-P54 error'#10#10'Error code: %08xH',[dwRes]);
  end;
	Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

